''
''
'' Remote Controlled Room Lamp
'' -- Jason Dorie --               
''               
''

CON
  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000

  'Approx 800 X 600?

  Radius = 300.0

  OuterRad = 300.0
  InnerRad = 153.0
  PointDist = 20.0  
  


OBJ
  Dbg:  "FullDuplexSerial.spin"
  Flt:  "Float32.spin"
  Disp: "Stepper.spin"


VAR
  long XPos, YPos
  long XTarget, YTarget


PUB Main | i
  DIRA[16..19]~~

  Dbg.Start( 31, 30, 0, 115200 )
  Flt.Start

  Disp.Init

  Spiro

{
  repeat i from 1 to 10
    Disp.Goto( i*80, 0 )
    Disp.Goto( 800, i*60 )
    Disp.Goto( 800-(i*80), 600 )
    Disp.Goto( 0, 600-(i*60) )
    Disp.Goto( i*80, 0 )  
 }
 
  'Disp.Goto(0, 0)

  Disp.ReleaseMotors

  repeat



PUB GetCirclePoint(ang, rad, X, Y) | fang
  fang := Flt.FMul( Flt.FFloat( ang ) , constant(3.141592654 / 32768.0 ) )  
  long[X] := Flt.FRound( Flt.FMul( Flt.Sin(fang) , rad) )
  long[Y] := Flt.FRound( Flt.FMul( Flt.Cos(fang) , rad) )
 

PUB Spiro | innerAngle, outerAngle, r1, r2, ox, oy, i, ix, iy, ratio

  innerAngle := 0
  outerAngle := 0

  r1 := flt.FSub(OuterRad, InnerRad)
  r2 := flt.FSub(InnerRad, PointDist)
  ratio := flt.fdiv( OuterRad , InnerRad )

  repeat i from 0 to 2000
    GetCirclePoint(outerAngle, r1, @ox, @oy)
    GetCirclePoint(innerAngle, r2, @ix, @iy)

    Disp.Goto( 400 + ox + ix, 300 + oy + iy)

    if( i == 0 )
      Disp.ReleaseMotors
      waitcnt( constant(80_000_000 * 6) + cnt )    
 
    outerAngle += 380
    innerAngle -= flt.fround( flt.fmul( 380.0 , ratio ) )

    